$(document).ready(function(){
  $("#jquery_jplayer_1").jPlayer({
    ended: function (event) {
      playNext();
    },    
    timeupdate: function(event) { 
      changeProgressBar(event.jPlayer.status.currentTime, event.jPlayer.status.duration);
    },  
    swfPath: "./app/js",
    supplied: "mp3",
    solution: "html,flash",
    volume: 1,
    muted: false,
    cssSelectorAncestor: '#jp_interface_1',
    errorAlerts: false,
    warningAlerts: false    
  });

  $("#jquery_jplayer_1").jPlayer("volume", 1);

  $("#jp_interface_1 .jp-previous").on("click.audiostreamer", function() {
    playPrev();
  });

  $("#jp_interface_1 .jp-next").on("click.audiostreamer", function() {
    playNext();
  });

//  $("#jquery_jplayer_1").bind($.jPlayer.event.timeupdate, function(event) { 
//    changeProgressBar(event.jPlayer.status.currentTime, event.jPlayer.status.duration);
//  });
  
  $( "#playlistSortable" ).sortable({
    placeholder: "ui-state-highlight",
    handle: ".move"
  });

  draggable();
  getTree();
  getAlbums();
  getSearch();
  showTreeWrap();
  recallDesktop();
  manageDesktops(0,0);
  manageUsers(0);
  manageSettings(0);
  manageLogging(0);
  aboutAudioStreamer(0);
  attachEvents();
  initWebAudioApi();
});

function draggable(){
  $('.drag').draggable({ 
    snap: true, 
    stack: '.drag',
    handle: 'div.handler',
    start: function(event, ui) {$('.iframe-style').css({display:"none"});},
    stop: function(event, ui) {$('.iframe-style').css({display:"block"});}
  });
  $('.drag').resizable({ 
    handles: ('n,e,s,w,ne,nw,se,sw'),
    start: function(event, ui) {$('.iframe-style').css({display:"none"});},
    stop: function(event, ui) {$('.iframe-style').css({display:"block"});
                               resizeImageWrap();
                               resizeFreqSpectrumWrap();
                              }
  });
}
function attachEvents() {
  //playlist actions
  $(".radio-playlist").on("click.audiostreamer", function() {
    radioPlaylist();
  });
  $(".clear-playlist").on("click.audiostreamer", function() {
    clearPlaylist();
  });
  //view drag divs
  $(".view-menu").on("click.audiostreamer", function() {
    viewMenuWrap();
  });  
  $(".showPlayer").on("click.audiostreamer", function() {
    showPlayerWrap();
  });  
  $(".showTree").on("click.audiostreamer", function() {
    showTreeWrap();
  });  
  $(".showAlbums").on("click.audiostreamer", function() {
    showAlbumsWrap();
  });  
  $(".showSearch").on("click.audiostreamer", function() {
    searchWrap();
  });  
  $(".view-albums").on("click.audiostreamer", function() {
    viewAlbumsWrap();
  });  
  $(".view-playlist").on("click.audiostreamer", function() {
    viewPlaylistWrap();
  });  
  $(".view-now-playing").on("click.audiostreamer", function() {
    viewNowPlayingWrap();
  });  
  $(".freq-spectrum").on("click.audiostreamer", function() {
    viewFreqSpectrumWrap();
  });  
  $(".desktop-save").on("click.audiostreamer", function() {
    saveDesktopWrap();
  });  
  $(".desktop-save-as").on("click.audiostreamer", function() {
    saveDesktopAsWrap();
  });  
  $(".desktop-manage").on("click.audiostreamer", function() {
    manageDesktopsWrap();
  });  
  $(".users").on("click.audiostreamer", function() {
    manageUsersWrap();
  });  
  $(".settings").on("click.audiostreamer", function() {
    manageSettingsWrap();
  });  
  $(".view-song-info").on("click.audiostreamer", function() {
    viewSongInfoWrap();
  });  
  $(".view-logging").on("click.audiostreamer", function() {
    viewLoggingWrap();
  });  
  $(".view-create-database").on("click.audiostreamer", function() {
    viewCreateDatabaseWrap();
  });  
  $(".about-AudioStreamer").on("click.audiostreamer", function() {
    aboutAudioStreamerWrap();
  });  
  $(".logout").on("click.audiostreamer", function() {
    logoutWrap();
  });  
  //close popup
  $(".close-popup").on("click.audiostreamer", function() {
    $(this).closest(".drag").css({'display' : 'none'}).find('iframe').css({'display' : 'none'});
  });
}

//Wrapper functions, see also the theme js-files
function viewMenuWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.viewMenu) == 'function')) {
    this.themeObj.viewMenu.apply(this, arguments);
  } else {
    this.viewMenu.apply(this, arguments);
  }
}  
function showPlayerWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.showPlayer) == 'function')) {
    this.themeObj.showPlayer.apply(this, arguments);
  } else {
    this.showPlayer.apply(this, arguments);
  }
}  
function showTreeWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.showTree) == 'function')) {
    this.themeObj.showTree.apply(this, arguments);
  } else {
    this.showTree.apply(this, arguments);
  }
}  
function showAlbumsWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.showAlbums) == 'function')) {
    this.themeObj.showAlbums.apply(this, arguments);
  } else {
    this.showAlbums.apply(this, arguments);
  }
}  
function searchWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.search) == 'function')) {
    this.themeObj.search.apply(this, arguments);
  } else {
    this.search.apply(this, arguments);
  }
}
function viewAlbumsWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.viewAlbums) == 'function')) {
    this.themeObj.viewAlbums.apply(this, arguments);
  } else {
    this.viewAlbums.apply(this, arguments);
  }
}  
function viewPlaylistWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.viewPlaylist) == 'function')) {
    this.themeObj.viewPlaylist.apply(this, arguments);
  } else {
    this.viewPlaylist.apply(this, arguments);
  }
}  
function viewNowPlayingWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.viewNowPlaying) == 'function')) {
    this.themeObj.viewNowPlaying.apply(this, arguments);
  } else {
    this.viewNowPlaying.apply(this, arguments);
  }
}  
function viewFreqSpectrumWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.viewFreqSpectrum) == 'function')) {
    this.themeObj.viewFreqSpectrum.apply(this, arguments);
  } else {
    this.viewFreqSpectrum.apply(this, arguments);
  }
}  
function saveDesktopWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.saveDesktop) == 'function')) {
    this.themeObj.saveDesktop.apply(this, arguments);
  } else {
    this.saveDesktop.apply(this, arguments);
  }
}  
function saveDesktopAsWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.saveDesktopAs) == 'function')) {
    this.themeObj.saveDesktopAs.apply(this, arguments);
  } else {
    this.saveDesktopAs.apply(this, arguments);
  }
}  
function manageDesktopsWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.manageDesktops) == 'function')) {
    this.themeObj.manageDesktops.apply(this, arguments);
  } else {
    this.manageDesktops.apply(this, arguments);
  }
}  
function manageUsersWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.manageUsers) == 'function')) {
    this.themeObj.manageUsers.apply(this, arguments);
  } else {
    this.manageUsers.apply(this, arguments);
  }  
}  
function manageSettingsWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.manageSettings) == 'function')) {
    this.themeObj.manageSettings.apply(this, arguments);
  } else {
    this.manageSettings.apply(this, arguments);
  }
}  
function viewSongInfoWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.viewSongInfo) == 'function')) {
    this.themeObj.viewSongInfo.apply(this, arguments);
  } else {
    this.viewSongInfo.apply(this, arguments);
  }
}  
function viewLoggingWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.viewLogging) == 'function')) {
    this.themeObj.viewLogging.apply(this, arguments);
  } else {
    this.viewLogging.apply(this, arguments);
  }
}  
function viewCreateDatabaseWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.viewCreateDatabase) == 'function')) {
    this.themeObj.viewCreateDatabase.apply(this, arguments);
  } else {
    this.viewCreateDatabase.apply(this, arguments);
  }
}  
function aboutAudioStreamerWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.aboutAudioStreamer) == 'function')) {
    this.themeObj.aboutAudioStreamer.apply(this, arguments);
  } else {
    this.aboutAudioStreamer.apply(this, arguments);
  }
}  
function logoutWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.logout) == 'function')) {
    this.themeObj.logout.apply(this, arguments);
  } else {
    this.logout.apply(this, arguments);
  }
}  
function resizeImageWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.resizeImage) == 'function')) {
    this.themeObj.resizeImage.apply(this, arguments);
  } else {
    this.resizeImage.apply(this, arguments);
  }
}  
function resizeFreqSpectrumWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.resizeFreqSpectrum) == 'function')) {
    this.themeObj.resizeFreqSpectrum.apply(this, arguments);
  } else {
    this.resizeFreqSpectrum.apply(this, arguments);
  }
}  
function scrollFocusWrap() {
  if ((typeof(themeObj) != 'undefined') && (typeof(themeObj.scrollFocus) == 'function')) {
    this.themeObj.scrollFocus.apply(this, arguments);
  } else {
    this.scrollFocus.apply(this, arguments);
  }
}  

function genreRadio(){
  //check if radio is on
  if ($("#drag5 .handler .radio-playlist").hasClass("radio-on")) {
    //get current playing song
    var hthis = $("#playlistSortable li .jp-playlist-current");
    var hid = $(hthis).attr("songId");
    //check if a song is playing
    if (hthis.length > 0) {
      //check if this is last song in playlist, if so add song automatically 
      var hnext = $(hthis).parent().next().children("a");
      if (hnext.length == 0) {
        $.get("./addNextRadioSong.php?id="+hid, function(data) {
          $("#playlistSortable").append(data);
        });  
      } 
    } 
  }
}
  
function playSong(hthis){
  var hmp3 = $(hthis).attr("mp3");
  
  if (hmp3!=undefined) {
    $("#jquery_jplayer_1").jPlayer("setMedia", {mp3: hmp3});
    $("#jquery_jplayer_1").jPlayer("play");
  
    $("#playlistSortable li a").removeClass("jp-playlist-current").parent().removeClass("jp-playlist-current");
    $(hthis).addClass("jp-playlist-current").parent().addClass("jp-playlist-current");
    
    $(".jp-progress-title").empty().append($(hthis).html());
    $("title").empty().append($(hthis).html());
    
    //Change now playing cover
    var hid = $(hthis).attr("songId");
    //var hcover = '<div class="top-spacer"></div><img id="coverNowPlaying'+hid+'" onClick="showImage(this)" title="zoom" class="cover-now-playing" src="./getCover.php?id='+hid+'&resize=0">';
    var hcover = '<div class="top-spacer"></div><img onClick="showImage(this)" title="zoom" class="cover-now-playing" src="./getCover.php?id='+hid+'&resize=0">';
    $("#api4").empty().append(hcover);
    //resize cover art
    resizeImageWrap();   
    resizeFreqSpectrumWrap();
    
    //radio
    setTimeout(function(){genreRadio()}, 5000);    
  }
}

function playPrev(){
  var hthis = $("#playlistSortable li .jp-playlist-current");
  var hprev = $(hthis).parent().prev().children("a");

  playSong(hprev);
}

function playNext(){
  var hthis = $("#playlistSortable li .jp-playlist-current");
  var hnext = $(hthis).parent().next().children("a");

  playSong(hnext);
}

function autoStart(){
  //start auto playing first in playlist if no song is playing
  //
  //get current playing song
  var hthis = $("#playlistSortable li .jp-playlist-current");
  //check if no song is playing
  if (hthis.length == 0) {   
    //get first song in playlist
    var hthis = $("#playlistSortable li a").first();
    //start playing
    playSong(hthis);
  } 
}
  
function addSong(hmp3, hname, hid, hdur, hdurformat){
  var hSong = '<li><div onClick="deleteSong(this)" class="delete"><div>delete</div></div><div title="move up-down" class="move"><div>move</div></div><a href="#" onClick="playSong(this)" songId="'+hid+'" mp3="'+hmp3+'" dur="'+hdur+'"  dur="'+hdur+'" durformat="'+hdurformat+'" title="'+hname+'">'+hname+'</a></li>';
  $("#playlistSortable").append(hSong); 
  autoStart();
}

function addDirectories(hdir) {
  $.get("./addDirectories.php?id="+hdir, function(data) {
    $("#playlistSortable").append(data);
    autoStart();
  });
  //.complete(function() { autoStart(); });
}

function deleteSong(hthis){
  $(hthis).parent().remove();

  //radio
  genreRadio();
}

function radioPlaylist(){
  if (!$("#drag5 .handler .radio-playlist").hasClass("radio-on")){
    //set radio on
    var hthis = $("#playlistSortable li .jp-playlist-current");
    var hid = $(hthis).attr("songId");
    $("#drag5 .handler .radio-playlist").addClass("radio-on");
    //check radio
    genreRadio(hthis, hid);
  }
  else {
    //set radio off
    $("#drag5 .handler .radio-playlist").removeClass("radio-on");
  }
}  

function clearPlaylist(){
  $("#playlistSortable").empty();
}  

function resizeImage() {
  //height, width of api 
  //smallest size wins
  pwidth = $("#api4").innerWidth();
  pheight = $("#api4").innerHeight() - $("#api4 .top-spacer").height();

  psquare = Math.min(pwidth, pheight) + 'px';

  $("#api4 .cover-now-playing").css({'width' : psquare, 'height' : psquare});
}  

function resizeFreqSpectrum () {
  //height, width of api 
  pwidth = $("#api16").innerWidth();
  pheight = $("#api16").innerHeight() - $("#api16 .top-spacer").height();

  $("#api16 #visualisation").css({'width' : pwidth + 'px', 'height' : pheight + 'px'});
  
  //resize canvas to width and height of the outer div 
  $("#api16 #freqcanvas").width = pwidth;
  $("#api16 #freqcanvas").height = pheight;
};

function showImage(hthis) {
  //show image div and ajax loader
  $("#largeAlbumCover").html('<div class="ajax-loader"></div>')
    .fadeIn("fast")
    .css("position","absolute")
    .css("top", ( ($(window).height() - $("#largeAlbumCover").height()) / 2) +$(window).scrollTop() + "px")
    .css("left", ( ($(window).width() - $("#largeAlbumCover").width()) / 2) +$(window).scrollLeft() + "px")
    .css('z-index',maxZ("#largeAlbumCover"))
    .on("click.audiostreamer", function(){ $("#largeAlbumCover").fadeOut("fast"); });   

  //preload the image
  //take image url from parent link (href) in case of clicking on "album - song view" image
  //take image url from image (src) in case of clicking on "now playing" image  
  var himage = $(hthis).parent().attr("href");
  if (!himage) {
    himage = $(hthis).attr("src");
  }  
  imgPreload = new Image();
  //when preloading is done, display it
  imgPreload.onload = function() {
    //show popup with full size image
    $("#largeAlbumCover").html("<img id='largeAlbumCoverImage' src='"+himage+"' title='close' />");

    //recalculate height and width of image if image is bigger than window
    hheight = imgPreload.height;
    hwidth = imgPreload.width;

    hratio = hwidth / hheight;
    if (hwidth > $(window).width()) {
      hwidth = $(window).width();
      hheight = hwidth / hratio;
      $("#largeAlbumCoverImage").css("height",hheight);
      $("#largeAlbumCoverImage").css("width",hwidth);
    }
    if (hheight > $(window).height()) {
      hheight = $(window).height();
      hwidth = hheight * hratio;
      $("#largeAlbumCoverImage").css("height",hheight);
      $("#largeAlbumCoverImage").css("width",hwidth);
    }
    
    $("#largeAlbumCover")
      .css("top", ( ($(window).height() - hheight) / 2) + $(window).scrollTop() + "px")
      .css("left", ( ($(window).width() - hwidth) / 2) + $(window).scrollLeft() + "px");   
  }
  imgPreload.src = himage;
}  

function viewMenu() {
  $("#drag1").css({'display' : 'block' , 'z-index' : maxZ()});
}

function showPlayer() {
  $("#drag6").css({'display' : 'block' , 'z-index' : maxZ()});
}

function viewAlbums() {
  $("#drag2").css({'display' : 'block' , 'z-index' : maxZ()});
//  $(".view-current").removeClass('view-current');
//  $(".view-albums").addClass('view-current');
}
 
function viewPlaylist() {
  $("#drag5").css({'display' : 'block' , 'z-index' : maxZ()});
}

function viewNowPlaying() {
  $("#drag4").css({'display' : 'block' , 'z-index' : maxZ()});
}

function viewFreqSpectrum() {
  $("#drag16").css({'display' : 'block' , 'z-index' : maxZ()});
}

function viewSongInfo() {
  $("#drag8").css({'display' : 'block' , 'z-index' : maxZ()});
//  $(".view-current").removeClass('view-current');
//  $(".view-song-info").addClass('view-current');
}

function viewLogging() {
  $("#drag15").css({'display' : 'block' , 'z-index' : maxZ()});
//  $(".view-current").removeClass('view-current');
//  $(".view-logging").addClass('view-current');
}

function viewCreateDatabase() {
  $("#drag9").css({'display' : 'block' , 'z-index' : maxZ()});
//  $(".view-current").removeClass('view-current');
//  $(".view-create-database").addClass('view-current');
}

function getDirectory(pid) {
  $("#api2").empty().append('<div class="top-spacer"></div><div class="ajax-loader"></div>');
  $("#api2").load("./selectDirectories.php?id="+pid);
  viewAlbumsWrap();
}
  
function getTree() {
  $("#api3").empty().append('<div class="top-spacer"></div><div class="ajax-loader"></div>');
  $("#api3").load("./getTree.php");
}

function showTree() {
  $("#drag3").css({'display' : 'block' , 'z-index' : maxZ()});
//  $(".tree-albums-current").removeClass("tree-albums-current");
//  $(".showTree").addClass("tree-albums-current");
//  $("#api3").css({'display' : 'block'});
//  $("#api7").css({'display' : 'none'});
//  $("#api14").css({'display' : 'none'});
}

function getAlbums(pgenre,psort) {
  $("#api7").empty().append('<div class="top-spacer"></div><div class="ajax-loader"></div>');
  $("#api7").load("./getAlbums.php?genre="+encodeURIComponent(pgenre)
                                +'&sort='+encodeURIComponent(psort));
}

function showAlbums() {
  $("#drag7").css({'display' : 'block' , 'z-index' : maxZ()});
//  $(".tree-albums-current").removeClass("tree-albums-current");
//  $(".showAlbums").addClass("tree-albums-current");
//  $("#api3").css({'display' : 'none'});
//  $("#api7").css({'display' : 'block'});
//  $("#api14").css({'display' : 'none'});
}

function getSearch(pgenre,partist,palbum,psong,ppath) {
  $("#api14").empty().append('<div class="top-spacer"></div><div class="ajax-loader"></div>');
  $("#api14").load("./search.php?genre="+encodeURIComponent(pgenre)
                                +'&artist='+encodeURIComponent(partist)
                                +'&album='+encodeURIComponent(palbum)
                                +'&song='+encodeURIComponent(psong)
                                +'&path='+encodeURIComponent(ppath));
}

function search() {
  $("#drag14").css({'display' : 'block' , 'z-index' : maxZ()});
//  $(".tree-albums-current").removeClass("tree-albums-current");
//  $(".showSearch").addClass("tree-albums-current");
//  $("#api3").css({'display' : 'none'});
//  $("#api7").css({'display' : 'none'});
//  $("#api14").css({'display' : 'block'});
}
  
function maxZ(){
  //calculate highest z-index
  //and add one
  var hmaxZ = Math.max.apply(null,$.map($('.drag'), function(e,n){
    return parseInt($(e).css('z-index'))||1 ;
    }) 
  );
  return hmaxZ+1;
}  
  
function getSongDetails(pid) {
  $.get("./getSongDetails.php?id="+pid, function(data) {
    $("#api8").empty();
    $("#api8").append(data);
    viewSongInfoWrap();
  });  
}

function createDirectories(pind_append) {
  if (pind_append == 1) {
    htrue = true;
  }
  else if (confirm("Are you sure you want to (re)create the music database?\nThis could take several minutes or hours (depending on the size of the library).")) {
    htrue = true;
  }
  if (htrue === true) {
    $("#api9").empty();
    $("#api9").html('<iframe class="iframe-style" src="./createDirectories.php?ind_append='+pind_append+'"></iframe>');
    viewCreateDatabaseWrap();    
  }
}

function getID3(pid) {
  $("#getID3").empty().append('<div class="top-spacer"></div><div class="ajax-loader"></div>');
  $.get("./getID3.php?id="+pid, function(data) {
    $("#getID3").empty().append(data);
  });  
}
  
function manageDesktops(hind_all_users, hvisible) {
  $("#api12").empty().append('<div class="top-spacer"></div><div class="ajax-loader"></div>');
  $.get("./desktopCRUD.php?pmode=R&ind_all_users="+hind_all_users, function(data) {
    if (hvisible != 0) {
      $("#drag12").css({'display' : 'block' , 'z-index' : maxZ("#drag12")});
    }
    $("#api12").empty();
    $("#api12").append(data);
  });  
}

function manageUsers(hvisible) {
  $("#api11").empty().append('<div class="top-spacer"></div><div class="ajax-loader"></div>');
  $.get("./userCRUD.php?pmode=R", function(data) {
    if (hvisible != 0) {
      $("#drag11").css({'display' : 'block' , 'z-index' : maxZ("#drag11")});
    }
    $("#api11").empty();
    $("#api11").append(data);
  });  
}

function manageSettings(hvisible) {
  $("#api13").empty().append('<div class="top-spacer"></div><div class="ajax-loader"></div>');
  $.get("./settingCRUD.php?pmode=R", function(data) {
    if (hvisible != 0) {
      $("#drag13").css({'display' : 'block' , 'z-index' : maxZ("#drag13")});
    }
    $("#api13").empty();
    //$("#api13").append(data);
    $.get("./themeCRUD.php?pmode=R", function(data2) {
      $("#api13").append(data+data2);
    });  
  });  
}
  
function logout() {
  window.location.href="./login.php";
}
  
function aboutAudioStreamer(hvisible) {
  $.get("./aboutAudioStreamer.php", function(data) {
    if (hvisible != 0) {
      $("#drag10").css({'display' : 'block' , 'z-index' : maxZ("#drag10")});
    }
    $("#api10").empty();
    $("#api10").append(data);
  });  
}

function manageLogging(hvisible, pmode, psearch) {
  $("#api15").empty().append('<div class="top-spacer"></div><div class="ajax-loader"></div>');
  $.get("./logging.php?pmode="+encodeURIComponent(pmode)
                     +"&search="+encodeURIComponent(psearch), function(data) {
    if (hvisible != 0) {
      viewLoggingWrap();
    }
    $("#api15").empty();
    $("#api15").append(data);
  });  
}

function getParams(hthis) {
  hparams="";
  $(hthis).closest("tr").find("[updId]").each(function(){
    var hdetail = $(this);
//    if (hparams != ""){
//      hparams += "&"
//    }
    if (hdetail.attr("type")=='checkbox'){
      if (hdetail.is(":checked")){
        hparams += "&"+hdetail.attr("updId")+"=1";
      }
      else {
        hparams += "&"+hdetail.attr("updId")+"=0";
      }
    }
    else {
      hparams += "&"+hdetail.attr("updId")+"="+hdetail.val();
    }
   });
   return hparams;
 }
   
function desktopUpdate(hthis,hind_all_users) {
  hurl = "./desktopCRUD.php?pmode=U"+getParams(hthis)+"&ind_all_users="+hind_all_users; 
  $.get(hurl, function(data) {
    xmlDoc = $.parseXML( data );
    $xml = $( xmlDoc );    
    haction = '<script type="text/javascript">' + $xml.find("action").text() + '<\/script>';
    
    $("#api12").append(haction);
    if ($xml.find("status").text() == "SUCCESS") {
      $(hthis).closest("tr").find(".changed").removeClass("changed");
    }
  });  
  //requery
  //manageDesktops(hind_all_users);  
}
                         
function desktopCopy(hthis,hind_all_users) {
  hurl = "./desktopCRUD.php?pmode=C"+getParams(hthis); 
  $.get(hurl, function(data) {
    if (data != "SUCCESS") {
      alert(data);
    }
    //requery
    manageDesktops(hind_all_users);  
  });  
}

function desktopDelete(hthis,hind_all_users) {
  hurl = "./desktopCRUD.php?pmode=D"+getParams(hthis); 
  $.get(hurl, function(data) {
    if (data != "SUCCESS") {
      alert(data);
    }
    //requery
    manageDesktops(hind_all_users);  
  });  
}

function saveDesktop() {
  hcmd = "";
  $('.drag').each(function() {
    hcmd += "INSERT"+$(this).attr("id")+"','"+$(this).attr("style")+"');";
  });  

  hurl = "./saveDesktopItems.php"; 
  $.post(hurl, {type:'save', cmd: hcmd} , function(data) {
    if (data != "SUCCESS") {
      alert(data);
    }
  });
}

function saveDesktopAs() {
  var hname=prompt("Save desktop as ...","");
  if (hname!=null && hname!="") {
    hcmd = "";

    $('.drag').each(function() {
      hcmd += "INSERT"+$(this).attr("id")+"','"+$(this).attr("style")+"');";
    });  

    hurl = "./saveDesktopItems.php"; 
    $.post(hurl, {type:'saveAs', cmd: hcmd, name: hname} , function(data) {
      //if (data != "SUCCESS") {
      //  alert(data);
      //}
    });
  }
}

function themeswitchcss(hcss) {
  //add theme css file
  if (hcss) {
    //only add if new is different from current
    if ($("#themecss").attr("href") != hcss) {
      $("#themecss").prop('disabled',true).remove();
      $('head').append('<link id="themecss" rel="stylesheet" href="'+hcss+'" type="text/css" />');
    }
  }
}

function themeswitchjs(hjs) {
  //add theme js file
  if (hjs) {
    $("#themejs").remove();
    $('head').append('<script id="themejs" type="text/javascript" src="'+hjs+'"></script>');
  }
}

function recallDesktop(pmsg) {
  hurl = "./getDesktopItems.php"; 
  $.get(hurl, function(data) {
    xmlDoc = $.parseXML(data);
    $xml = $(xmlDoc);    

    if ($xml.find("status").text() == "SUCCESS") {    
      //recall styles of drag div's
      $xml.find("desktopitem").each(function() {
        $('#'+$(this).find("item").text()).attr("style", $(this).find("style").text());         
      });
      
      //resize the now playing image and the freq spectrum
      resizeImageWrap();
      resizeFreqSpectrumWrap();
      
      //recall the theme
      themeswitchcss($xml.find("css").text());
      themeswitchjs($xml.find("js").text());
    }

    if (pmsg == 1) {
      alert($xml.find("message").text());  
    }
  });  
}

function userUpdate(hthis) {
  hurl = "./userCRUD.php?pmode=U"+getParams(hthis); 
  $.get(hurl, function(data) {
    if (data != "SUCCESS") {
      alert(data);
    }
    else {
      $(hthis).closest("tr").find(".changed").removeClass("changed");
    }
  });  
  //requery
  //manageUsers();  
}
                         
function userCopy(hthis) {
  hurl = "./userCRUD.php?pmode=C"+getParams(hthis); 
  $.get(hurl, function(data) {
    if (data != "SUCCESS") {
      alert(data);
    }
    //requery
    manageUsers();  
  });  
}

function userDelete(hthis) {
  hurl = "./userCRUD.php?pmode=D"+getParams(hthis); 
  $.get(hurl, function(data) {
    if (data != "SUCCESS") {
      alert(data);
    }
    //requery
    manageUsers();  
  });  
}

function settingUpdate(hthis) {
  hurl = "./settingCRUD.php?pmode=U"+getParams(hthis); 
  $.get(hurl, function(data) {
    if (data != "SUCCESS") {
      alert(data);
    }
    else {
      $(hthis).closest("tr").find(".changed").removeClass("changed");
    }
  });  
  //requery
  //manageSettings();  
}

function themeUpdate(hthis) {
  hurl = "./themeCRUD.php?pmode=U"+getParams(hthis); 
  $.get(hurl, function(data) {
    if (data != "SUCCESS") {
      alert(data);
    }
    else {
      $(hthis).closest("tr").find(".changed").removeClass("changed");
    }
  });  
  //requery
  //manageSettings();  
}
                         
function themeCopy(hthis) {
  hurl = "./themeCRUD.php?pmode=C"+getParams(hthis); 
  $.get(hurl, function(data) {
    if (data != "SUCCESS") {
      alert(data);
    }
    //requery
    manageSettings();  
  });  
}

function themeDelete(hthis) {
  hurl = "./themeCRUD.php?pmode=D"+getParams(hthis); 
  $.get(hurl, function(data) {
    if (data != "SUCCESS") {
      alert(data);
    }
    //requery
    manageSettings();  
  });  
}

function changeProgressBar(psec, pjdur) {
  //get current playing song
  var hthis = $("#playlistSortable li .jp-playlist-current");
  var pdur = $(hthis).attr("dur");
  var pdurformat = $(hthis).attr("durformat");
  var pwidth = 0;
  if (pjdur=='Infinity' || pjdur==0) {
    //if jPlayer duration = Infinity (NaN:NaN) or zero then we will be doing the progressbar
    //otherwise let jPlayer do it
    //
    //hide jPlayer duration and play-bar and show audiostreamers
    if ($("div.jp-duration").is(":visible")) {
      $("div.jp-duration").hide();
      $("div.as-duration").show();
    }
    if ($("div.jp-play-bar").is(":visible")) {
      $("div.jp-play-bar").hide();
      $("div.as-play-bar").show();
    }
    //change the duration
    $("div.as-duration").html(pdurformat);
    //change the progresbar
    pwidth = (psec/pdur)*100;
    if (pwidth > 100) {
      pwidth = 100;
    }
    $(".jp-interface .as-play-bar").css({'width' : pwidth+'%'});
  } else {
    //show jPlayer duration and play-bar and hide audiostreamers
    if ($("div.as-duration").is(":visible")) {
      $("div.jp-duration").show();
      $("div.as-duration").hide();
    }
    if ($("div.as-play-bar").is(":visible")) {
      $("div.jp-play-bar").show();
      $("div.as-play-bar").hide();
    }
  }
}    
  
//custom jquery filter: instead of finding all matched content only finds content that starts with a given string
$.expr[":"].startsWith = function(el, i, m) {
  var search = m[3];        
  if (!search) return false;
  return eval("/^[/]*" + search + "/i").test($(el).text());
};

function scrollFocus(hthis) {
  hapi = "#"+$(hthis).closest(".api").attr("id");

  if ($(hapi+" .scrollfield").val() == "") {
    $(hapi).scrollTop(0);
    $(hapi+" #tree li").removeClass("highlighted");
  } else {
    $(hapi+" #tree li").removeClass("highlighted");
    $(hapi+" #tree li:startsWith("+$(hapi+" .scrollfield").val()+")").addClass("highlighted");
    if ($(hapi+" .highlighted").length != 0) {$(hapi).scrollTop($(hapi+" .highlighted").position().top - $(hapi+" .top-spacer").height())};
  }
}

function initWebAudioApi() {
  //
  //If visuals button exists enable Web Audio Api, otherwise don't  
  if ($("#api1 .freq-spectrum").length == 1) {
    //"use strict";
    
    //
    //get the context from the canvas to draw on
    var freqcanvas = document.getElementById('freqcanvas');
    var freqctx = freqcanvas.getContext("2d");
    // create a temp canvas we use for copying and scrolling
    var tempcanvas = document.createElement("canvas");
    var tempctx = tempcanvas.getContext("2d");
    //gradient for the spectrogram
    var rainbow = new Rainbow();
    rainbow.setSpectrum('black','blue','green','yellow','orange','red','white');
    //
    var animId = 0;
    var animTimerId;
    var renderTimerId;
    var hmessage;
    //
    var hchoice = $("#visualSelect").val();
    var hchoiceprev;
    
    // http://www.smartjava.org/content/exploring-html5-web-audio-visualizing-sound
    // create the audio context
    var context;
    if (typeof AudioContext !== "undefined") {
      context = new AudioContext();
    } else if (typeof webkitAudioContext !== "undefined") {
      context = new webkitAudioContext();
    } else {
      hmessage = '<div>'
        +'Sorry, the frequency spectrum won\'t work.'
        +'<br />Your browser does not support the html5 Web Audio Api.'
        +'<br />'
        +'<br />You can always try it in Chrome or FireFox(FF25 and up).'
        +'</div>';
      $("#visualisation").empty().append(hmessage);
      return;
        }
    
    if ($("#jp_audio_0").length == 0) {
      hmessage = '<div>'
        +'Sorry, the frequency spectrum won\'t work.'
        +'<br />Your browser uses the flash solution to play mp3 files.'
        +'<br />'
        +'<br />The html5 (Web Audio Api) audio solution is required.'
        +'</div>';
      $("#visualisation").empty().append(hmessage);
      return;
        }
    //
    var audioElement = document.getElementById("jp_audio_0");
    var source = context.createMediaElementSource(audioElement);
    
    //setup analyser
    var analyser = context.createAnalyser();
    analyser.fftSize = 2048;
    analyser.minDecibels = -100;
    analyser.maxDecibels = 0;
    //setup analyser2
    var analyser2 = context.createAnalyser();
    analyser2.fftSize = 2048;
    analyser2.minDecibels = -100;
    analyser2.maxDecibels = 0;
    
    //connect the source to the analyser
    source.connect(analyser);
    source.connect(analyser2);
    //and connect to destination
    source.connect(context.destination);  
    
    window.requestAnimFrame = (function(callback) {
      return window.requestAnimationFrame || window.webkitRequestAnimationFrame
        || window.mozRequestAnimationFrame || window.oRequestAnimationFrame
        || window.msRequestAnimationFrame || function(callback) {
          animTimerId = window.setTimeout(callback, 1000 / 60);
        };
    })();
    
    window.cancelAnimFrame = (function(handle) {
      return window.cancelAnimationFrame || window.webkitCancelAnimationFrame
        || window.mozCancelAnimationFrame || window.oCancelAnimationFrame
        || window.msCancelAnimationFrame || function(handle) {
          clearTimeout(animTimerId);
        };
    })();
    
    $("#jp_audio_0").on('pause', function() {
      //
      //cancel last animation frame
      clearTimeout(renderTimerId);
      if (animId) { window.cancelAnimFrame(animId); } 
      //reset analyser smoothingConstant
      analyser.smoothingTimeConstant = 1;    
      analyser2.smoothingTimeConstant = 1;    
    });        
    $("#jp_audio_0").on('play', function() {
      //
      //cancel last animation frame
      clearTimeout(renderTimerId);
      if (animId) { window.cancelAnimFrame(animId); } 
      //reset analyser smoothingConstant
      analyser.smoothingTimeConstant = 0.3;    
      analyser2.smoothingTimeConstant = 0;    
      setTimeout(function(){
        //set analyser smoothingConstant values back
        //without timer this won't work        
        analyser.smoothingTimeConstant = 0.3;    
        analyser2.smoothingTimeConstant = 0.99;    
      },300);  
      //draw spectrums
      render();
    });        
    
    //draw the grid and spectrums
    function render() {
      //through requesting new frame is good, but gives rather high cpu...
      //therefore extra timeout
      renderTimerId = window.setTimeout(function(){
        animId = window.requestAnimFrame(render);    
      }, 100);
      
      //if song is playing and spectrum is visible then redraw
      if (!audioElement.paused && $("#drag16:visible").length!=0) {
        var freqarray = new Uint8Array(analyser.frequencyBinCount);
        var freqarray2 = new Uint8Array(analyser2.frequencyBinCount);
        var timearray = new Uint8Array(analyser.frequencyBinCount);
        analyser.getByteFrequencyData(freqarray);  
        analyser2.getByteFrequencyData(freqarray2);  
        analyser.getByteTimeDomainData(timearray);  
        
        //if height or width is different then
        //resize canvas to width and height of the outer div
        if (freqctx.canvas.width != $("#visualisation").width()) {
          freqctx.canvas.width = $("#visualisation").width();
        }
        if (freqctx.canvas.height != $("#visualisation").height()) {
          freqctx.canvas.height = $("#visualisation").height();
        }
        //
        hchoiceprev = hchoice;
        hchoice = $("#visualSelect").val();
        if (hchoiceprev != hchoice) {
          //clear the current state
          freqctx.clearRect(0, 0, freqcanvas.width, freqcanvas.height);
        }
        if (hchoice=='FREQ') {
          //FREQUENCY
          //clear the current state
          freqctx.clearRect(0, 0, freqcanvas.width, freqcanvas.height);
          //set temp-canvas to zero
          tempctx.canvas.width = 0;
          tempctx.canvas.height = 0;
          
          drawFreqLine(freqarray);
          drawGrid();
          drawFreqLine2(freqarray2);
          //drawTime(timearray);
        } else if (hchoice=='SPECTRO') {
          //SPECTROGRAM
          //set temp canvas to same size
          tempctx.canvas.width = freqctx.canvas.width;
          tempctx.canvas.height = freqctx.canvas.height;        
          
          drawSpectro(freqarray);
        } else if (hchoice=='OSC') {
          //OSCILLATOR
          //clear the current state
          freqctx.clearRect(0, 0, freqcanvas.width, freqcanvas.height);
          //set temp-canvas to zero
          tempctx.canvas.width = 0;
          tempctx.canvas.height = 0;
          
          drawTime(timearray);
        } else if (hchoice=='WAVE') {
          //WAVEFORM
          //set temp canvas to same size
          tempctx.canvas.width = freqctx.canvas.width;
          tempctx.canvas.height = freqctx.canvas.height;        
          
          drawWave(timearray);
        }
      }
    }
    
    function drawFreqLine(freqarray) {
      // Draw the frequency domain chart.
      freqctx.beginPath();
      freqctx.moveTo(0,freqcanvas.height);
      for (var i = 0; i < (freqarray.length); i++) {
        var value = freqarray[i];
        var percent = value / 256;
        var height = freqcanvas.height * percent;
        var offset = freqcanvas.height - height - 1;
        var hfreq = Math.round(i*context.sampleRate/analyser.fftSize); 
        var xpos = Math.round((Math.log(hfreq/10)*freqcanvas.width)/Math.log(context.sampleRate/20));
        if (i==0) { xpos = 0;}
        freqctx.lineTo(xpos, offset);
      }
      freqctx.lineTo(freqcanvas.width, freqcanvas.height);
      // Fill the path
      var gradient = freqctx.createLinearGradient(0,0,0,freqcanvas.height);
      gradient.addColorStop(1,'#550000');
      gradient.addColorStop(0.75,'#ff0000');
      gradient.addColorStop(0.25,'#ffff00');
      gradient.addColorStop(0,'#ffff00');
      freqctx.fillStyle=gradient;
      
      freqctx.fill();
      freqctx.closePath();
    }
    
    function drawFreqLine2(freqarray) {
      // Draw the frequency domain chart.
      freqctx.beginPath();
      freqctx.moveTo(0,freqcanvas.height);
      for (var i = 0; i < (freqarray.length); i++) {
        var value = freqarray[i];
        var percent = value / 256;
        var height = freqcanvas.height * percent;
        var offset = freqcanvas.height - height - 1;
        var hfreq = Math.round(i*context.sampleRate/analyser.fftSize); 
        var xpos = Math.round((Math.log(hfreq/10)*freqcanvas.width)/Math.log(context.sampleRate/20));
        if (i==0) { xpos = 0;}
        freqctx.lineWidth = 2;
        freqctx.lineTo(xpos, offset);
      }
      freqctx.lineTo(freqcanvas.width, freqcanvas.height);
      freqctx.strokeStyle = 'black';
      freqctx.stroke();
      //
      freqctx.closePath();
    }
    
    function drawGrid() {
      //
      // Draw the log-grid on the x-axis of the frequency domain chart.
      var gridx = [10,20,30,40,50,60,70,80,90,
                   100,200,300,400,500,600,700,800,900,
                   1000,2000,3000,4000,5000,6000,7000,8000,9000,
                   10000,20000];
      var labelx = ["","20","30","","50","","","","",
                    "100","","300","","500","","","","",
                    "1k","","3k","","5k","","","","",
                    "10k","20k"];
      freqctx.beginPath();   
      for (var i = 0; i < gridx.length; i++) {
        var xpos = Math.round((Math.log(gridx[i]/10)*freqcanvas.width)/Math.log(context.sampleRate/20)); 
        freqctx.moveTo(xpos, 0);
        freqctx.lineWidth = 0.3;
        freqctx.lineTo(xpos, freqcanvas.height-2);
        //
        freqctx.font = '7pt Tahoma';
        freqctx.fillStyle = 'black';
        freqctx.fillText(labelx[i], xpos+2, freqcanvas.height-3);
      }
      //freqctx.fillStyle = "#333333"
      freqctx.stroke();
      //
      freqctx.font = '7pt Tahoma';
      freqctx.fillStyle = 'black';
      freqctx.fillText('Sample Rate '+context.sampleRate, freqcanvas.width-85, 15);      
      freqctx.fillText('FFT Size '+analyser.fftSize, freqcanvas.width-70, 25);      
      //
      freqctx.closePath();
      //
      // Draw the grid on the y-axis of the frequency domain chart.
      var range = analyser.maxDecibels - analyser.minDecibels;
      
      freqctx.beginPath();   
      for (var i = 0; i < (range/10); i++) {
        var ypos = Math.round((i*freqcanvas.height)/(range/10)); 
        freqctx.moveTo(0, ypos);
        freqctx.lineWidth = 0.3;
        freqctx.lineTo(freqcanvas.width, ypos);
        //
        freqctx.font = '7pt Tahoma';
        freqctx.fillStyle = 'black';
        freqctx.fillText((analyser.maxDecibels-(i*10)), 2, ypos-2);
      }
      //freqctx.fillStyle = "#333333"
      freqctx.stroke();
      //
      freqctx.closePath();
    }
    
    function drawSpectro(freqarray) {
      // Draw the spectrogram chart.
      // copy the current canvas onto the temp canvas
      tempctx.drawImage(freqcanvas, 0,0);
      
      freqctx.beginPath();
      
      for (var i = 0; i < freqarray.length; i++) {
        // draw each pixel with the specific color
        var value = freqarray[i];
        var percent = value / 256;
        var hfreq = Math.round(i*context.sampleRate/analyser.fftSize); 
        var ypos;
        var yposprev = ypos;
        ypos = Math.round((Math.log(hfreq/10)*freqcanvas.height)/Math.log(context.sampleRate/20));
        if (i==0) { ypos = 0;}
        
        freqctx.fillStyle = "#"+rainbow.colourAt(percent*100);
        
        // draw the line at the right side of the canvas
        freqctx.fillRect(freqcanvas.width - 1, freqcanvas.height - ypos, 1, (ypos - yposprev));
      }
      freqctx.closePath();
      
      // restore main canvas
      freqctx.drawImage(tempcanvas, -1,0);    
    }
    
    function drawTime(timearray) { 
      // Draw the time domain chart.
      freqctx.beginPath();   
      for (var i = 0; i < (timearray.length); i++) {
        var value = timearray[i];
        var percent = value / 256;
        var height = freqcanvas.height * percent;
        var ypos = freqcanvas.height - height - 1;
        var barWidth = freqcanvas.width/timearray.length;
        if (barWidth <= 1) {barWidth = 1;}
        //freqctx.fillStyle = 'black';
        //freqctx.fillRect(i * barWidth, ypos, 2, barWidth);   
        freqctx.lineWidth = 2;
        freqctx.lineTo(i * barWidth, ypos);
      }
      freqctx.stroke();
      //
      freqctx.closePath();
    }
    
    function drawWave(timearray) {
      // Draw the waveform.
      // copy the current canvas onto the temp canvas
      tempctx.drawImage(freqcanvas, 0,0);
      
      freqctx.beginPath();
      //clear last painted pixels on the right of the canvas
      freqctx.fillStyle = 'white';
      freqctx.fillRect(freqcanvas.width - 1, 0, 1, freqcanvas.height);   
      for (var i = 0; i < timearray.length; i++) {
        var value = timearray[i];
        var percent = value / 256;
        var height = freqcanvas.height * percent;
        var ypos = freqcanvas.height - height - 1;
        //freqctx.fillStyle = 'black';
        //freqctx.fillRect(freqcanvas.width - 1, ypos, 1, 1);   
        freqctx.lineWidth = 1;
        freqctx.lineTo(freqcanvas.width - 1, ypos);
      }
      freqctx.stroke();
      //
      freqctx.closePath();
      
      // restore main canvas
      freqctx.drawImage(tempcanvas, -1,0);    
    }  
  }
}
